#include "structures.h"
#include <stdio.h>

void trace(char str[]);

// Chargements

char		*readAdress(FILE *flot);
Offre 		**initTabTravaux(void);
Offre 		**loadOffre(void);
void		loadDevis(FILE *devisFile, Offre **tabTravaux);
Tache		**loadTaches(Offre **tabTravaux);
Precedence	*loadPrec(int *tmax, int *tlog);


// Recherches et tri

int 		rechTravaux(char *travauxName, Offre **tabTravaux);
void		minTravaux(Offre **tabTravaux);
void 	freeListeDevis(ListeDevis *ldevis);
void	fusionDevisElements(ListeDevis *R, int *tlogR, ListeDevis *S, int *tlogS, ListeDevis *mergedList, ListeDevis *last, int *k);
void	gestionElementsRestants(ListeDevis *mergedList, ListeDevis *last, ListeDevis *source, int *tlogSource, int *k);
void	fusionMaillonDevis(ListeDevis R, int tlogR, ListeDevis S, int tlogS, ListeDevis *T);
void	triFusionListeDevis(ListeDevis *ldevis, int tlog);


// Fonctions de base -> Qui étaient bien dans structures.h...

int			lenListeDevis(ListeDevis l);
int			nombrePred(char travaux[], Precedence prec[], int tlog);
void		displayDevis(Devis d);
void		displayOffre(Offre *o);
void		displayListeDevis(ListeDevis l);
Offre		*newOffre(char *travauxName);
Booleen		emptyListe(ListeDevis l);
Booleen		emptyOffre(Offre *o);
Liste		newListe(void);
Liste		insertSucc(Liste l, char travaux[]);
Liste		lstSucc(char travaux[], Precedence prec[], int tlog);
ListeDevis	del(ListeDevis l);
ListeDevis	insert(ListeDevis l, Devis d);
ListeDevis	newListeDevis(void);
int 		longueurMaxNomEntreprise(ListeDevis ldevis);
void 		afficherDevisEntreprise(Offre **tabTravaux);
void displayPrecedences(Precedence *tabP, int tlog);

